Problem with script


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Problem with script
# 1  
Old 02-19-2010
Problem with script

Hi,

I am checking for the existence of a file in my script and if the file is not found script should fail.

Below is what I have put together. But the script is not returning correct retrurn code. I need the script to fail if the file is not found. what should i do below for the script to fail?
Code:
if  [ -e $work_FILE ]
then echo "File is found"
errorcode=$?
else
if [[ $errorCode -ne 0 ]]
then
return $errorCode
fi
fi


Last edited by Scott; 02-19-2010 at 03:58 PM.. Reason: Please use code tags
# 2  
Old 02-19-2010
Code:
errorcode=$?

is returning the exit code from the echo statement, not from the test.

Code:
[ -e "$work_FILE" ] || return 1

# 3  
Old 02-19-2010
the script is not failing. i want the script to fail but its not happening

if [ -f "test.txt" ] || return 1
then
return 0
fi

with the code above

return value is 1 but script is not failing
# 4  
Old 02-19-2010
Code:
if [ ! -f "test.txt" ]; then
 exit 1
fi
exit 0

# 5  
Old 02-21-2010
Use always "$variable", not $variable.
Why ?
Ex. test command need some argument(s) and if value of variable is null, it's syntax error. But if you write "$var", it's always string, which length is 0 or more.
Read man test. So, it's more safety to use "$var" always as only $var. Ex. when using filenames and your filesystem filenames can include ex. spaces.

return = used in function, exit the function like exit do for whole script
Code:
#cmd1 || cmd2    = if cmd1 exit status is not 0 then do cmd2
#cmd1 && cmd2    = if cmd1 exit status is 0 then do cmd2
[ -e "$work_FILE" ] || exit 1

or same answer using if
Code:
if [ -e "$work_FILE" ] ; then
    exit 1
fi


Last edited by kshji; 02-21-2010 at 03:51 AM..
# 6  
Old 02-21-2010
Both "scottn" and "kshij" have the correct solution.
The "return" command is only relevant to a script called from another script.
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Problem in calling a script inside a script

Hi team, I have a script in different folder. Now i want to call that script and execute that script from that path alone. My code is #!/bin/bash wname=yahoo PATH='/opt/IBM' wac=`/usr/bin/ls $PATH | /usr/bin/grep "$wname"` STOP=`/usr/bin/find $PATH/$wac -type f -name "stop.sh"`... (8 Replies)
Discussion started by: natraj005
8 Replies

2. Shell Programming and Scripting

Shell script newbie, what is problem with my script?

Hello, Ubuntu server 11.10 can anybody help what is problem with my shell script? #!/bin/bash #script to find out currently logged on user is root or not. if ] then echo "You are super" else echo "You are awesome!" fi When I run script, I get following output ./uid: line 3: I... (4 Replies)
Discussion started by: kaustubh
4 Replies

3. Shell Programming and Scripting

Problem while calling a script within a script

Hi , I have moduled my scripts in three scripts . From First script i am calling second and from second i am calling third for some check . Problem is with the third script call. ---In second script EXP ='test.\abc.\Server.*abc.xml.*' pid=$($HOME/bin/checkpid $EXP) --Third... (2 Replies)
Discussion started by: amrishn
2 Replies

4. Shell Programming and Scripting

Problem running a program/script in the background from a script

Hi all, I have a script that calls another program/script, xxx, to run in the background. Supposedly this program at most should finish within five (5) minutes so after five (5) minutes, I run some other steps to run the script into completion. My problem is sometimes the program takes... (5 Replies)
Discussion started by: newbie_01
5 Replies

5. Shell Programming and Scripting

Problem with a script

Hi everyone, I got a problem with a script. What it's supposed to do is: to take as arguments a directory name <dir> and a dimension (in byte) <dim>; if <dir> exists, to write name and dimension of every regular file within it that sizes lesser than <dim> in regFileList. Nothing happens... (10 Replies)
Discussion started by: Luke Bonham
10 Replies

6. UNIX for Dummies Questions & Answers

Problem with script

Hello All. I have a script that is suppossed to start up a daemon but when executed, simply hangs. Could you please take a look and let me know where the problem might be? TIA ################################################################### # # SCRIPT: dstart3000.sh # Bring up the Domain... (6 Replies)
Discussion started by: grin1dan
6 Replies

7. Shell Programming and Scripting

call shell script from perl cgi script problem

hi,, i have perl scipt with line : system('./try.sh $t $d $m'); in shell scipt try.sh i have the line: echo $1 its not printing value of $t that i hav passed..y is it so..i am running it from apache web server (2 Replies)
Discussion started by: raksha.s
2 Replies

8. Shell Programming and Scripting

ssh script problem problem

Hi Please help me with the following problem with my script. The following block of code is not repeating in the while loop and exiting after searching for first message. input_file ========== host001-01 host001-02 2008-07-23 13:02:04,651 ConnectionFactory - Setting session state... (2 Replies)
Discussion started by: pcjandyala
2 Replies

9. Shell Programming and Scripting

Help. Script problem

hey guys. i have a bunch of programs in a script that needs to run as root and the rest as another user, we'll call him gabriel. now, in this script, i want to run the first few lines as root. now, how do i, after running as root, tell the script to run the remaining lines as the user gabriel?... (3 Replies)
Discussion started by: Terrible
3 Replies

10. UNIX for Dummies Questions & Answers

Problem starting a script from a 'main'-script

Please Help! :o I have a main script (ksh) where another script is called (convert_picture). Normally this works ok, but since some changes has been made on the unix-server (I dont know what :( ) suddenly it doesnt work anymore: i get an error message: ksh: convert_picture not found. I am... (3 Replies)
Discussion started by: Rakker
3 Replies
Login or Register to Ask a Question